
/*
 * Catweasel -- Advanced Floppy Controller
 * Linux device driver
 * Data common to all encoders (header)
 *
 * Copyright (C) 1998-2002 Michael Krause
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _ENCODER_COMMON_H
#define _ENCODER_COMMON_H

struct cw_codec {
    int (*decode)(struct cw_drive_struct *drive,
		  int side,
		  int thresh_offset);
    void (*encode)(struct cw_drive_struct *drive,
		   int side);
};

void codec_msdos_init(void);

extern unsigned char threshtab[128];

void
codec_init_threshtab(int try,
		     const unsigned char *origt);

void
put_normal(const char *mfmenc,
	   int x,
	   int iobase);
void
put_precomp(const char *mfmenc,
	    int x,
	    int iobase);

#ifndef NO_PRECOMP

#define PUT(X) putfunc(mfmenc, (X), iobase)

#else /* NO_PRECOMP */

#define PUT(X) outb(mfmenc[(X)], iobase)

#endif /* NO_PRECOMP */

void calc_time(int iobase);

#endif /* _ENCODER_COMMON_H */
